﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace FDK
{
	// 構造体

	public class CInputEvent
	{
		/// <summary>
		/// <para>デバイスのGUID。</para>
		/// <para>Joystickの場合のみ使用。その他のデバイスでは常に null。</para>
		/// </summary>
		public string GUID = null;

		/// <summary>
		/// <para>デバイス番号。</para>
		/// <para>MIDIの場合：MIDIデバイス番号(0～)</para>
		/// <para>Keyboardの場合：常に 0</para>
		/// <para>Joystickの場合：常に 0</para>
		/// </summary>
		public int ID = 0;

		/// <summary>
		/// <para>Keyboard の場合は SlimDX.DirectInput.Key を int にキャストしたもの。</para>
		/// <para>Midiの場合、255はフットペダルを表す。</para>
		/// </summary>
		public int nKey = 0;

		public bool b押された = false;
		public bool b離された
		{
			get
			{
				return !b押された;
			}
			set
			{
				b押された = !value;
			}
		}

		public long nTimeStamp = CTimer.n未使用;
		
		/// <summary>
		/// <para>押されたイベントの音量。MIDIデバイスでのみ可変(小:0～127:大)。</para>
		/// <para>その他のデバイスは常に定数（CInput管理.n通常音量）となる。</para>
		/// <para>放されたイベントの場合は常に 0 。</para>
		/// </summary>
		public int nVelocity = 0;
	}
}
