﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using SlimDX;
using SlimDX.DirectInput;

namespace FDK
{
	public class CInputJoystick : IInputDevice, IDisposable
	{
		public CInputJoystick( IntPtr hWnd, DeviceInstance di, DirectInput directInput )
		{
			this.e入力デバイス種別 = E入力デバイス種別.Joystick;
			this.GUID = di.InstanceGuid.ToString();
			this.ID = 0;	// 未使用

			#region [ ジョイスティックデバイスを生成する。 ]
			//-----------------
			try
			{
				this.devJoystick = new Joystick( directInput, di.InstanceGuid );
				this.devJoystick.SetCooperativeLevel( hWnd, CooperativeLevel.Foreground | CooperativeLevel.Exclusive );
				this.devJoystick.Properties.BufferSize = 32;
				this.strデバイス名 = this.devJoystick.Information.InstanceName;
			}
			catch
			{
				C共通.tDisposeする( ref this.devJoystick );
				throw;
			}
			//-----------------
			#endregion
			#region [ 軸オブジェクトの値域を設定する。 ]
			//-----------------
			foreach( var instance in this.devJoystick.GetObjects() )
			{
				if( ( instance.ObjectType & ObjectDeviceType.Axis ) != ObjectDeviceType.All )
				{
					this.devJoystick.GetObjectPropertiesById( (int) instance.ObjectType ).SetRange( -1000, 1000 );
				}
			}
			//-----------------
			#endregion
			#region [ ジョイスティックデバイスを Acquire する。]
			//-----------------
			try
			{
				this.devJoystick.Acquire();
			}
			catch( DirectInputException )
			{
				// 失敗しても、特に何もしない。
			}
			//-----------------
			#endregion

			#region [ ボタン状態配列を初期化。]
			//-----------------
			for( int i = 0; i < this.bButtonState.Length; i++ )
				this.bButtonState[ i ] = false;
			//-----------------
			#endregion
			#region [ タイマーを生成。]
			//-----------------
			this.timer = new CTimer( CTimer.E種別.MultiMedia );
			//-----------------
			#endregion
		}
		
		#region [ IInputDevice 実装 ]
		//-----------------
		public E入力デバイス種別 e入力デバイス種別
		{ 
			get;
			protected set;
		}
		public string GUID
		{
			get;
			protected set;
		}
		public int ID
		{ 
			get; 
			protected set;
		}
		public List<CInputEvent> list入力イベント 
		{
			get;
			protected set; 
		}
		public string strデバイス名
		{
			get;
			protected set;
		}

		public void tポーリング( bool bWindowがアクティブ中, bool bバッファ入力を使用する )
		{
			// 状態バッファをクリア。

			for( int i = 0; i < 256; i++ )
			{
				this.bButtonPushDown[ i ] = false;
				this.bButtonPullUp[ i ] = false;
			}


			// 入力イベントリストを作成。

			if( bWindowがアクティブ中 && 
				this.devJoystick.Acquire().IsSuccess &&
				this.devJoystick.Poll().IsSuccess )
			{
				this.list入力イベント = new List<CInputEvent>( 32 );

				if( bバッファ入力を使用する )
				{
					#region [ (A) バッファ入力 ]
					//-----------------------------

					var bufferedData = this.devJoystick.GetBufferedData();
					if( Result.Last.IsFailure || bufferedData == null )
						return;

					foreach( JoystickState data in bufferedData )
					{
						#region [ X軸－ ]
						//-----------------------------
						if( data.X < -500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 0,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 0 ] = true;
							this.bButtonPushDown[ 0 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 0,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 0 ] = false;
							this.bButtonPullUp[ 0 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ X軸＋ ]
						//-----------------------------
						if( data.X > 500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 1,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 1 ] = true;
							this.bButtonPushDown[ 1 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 1,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 1 ] = false;
							this.bButtonPullUp[ 1 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ Y軸－ ]
						//-----------------------------
						if( data.Y < -500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 2,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 2 ] = true;
							this.bButtonPushDown[ 2 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 2,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 2 ] = false;
							this.bButtonPullUp[ 2 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ Y軸＋ ]
						//-----------------------------
						if( data.Y > 500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 3,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 3 ] = true;
							this.bButtonPushDown[ 3 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 3,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 3 ] = false;
							this.bButtonPullUp[ 3 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ Z軸－ ]
						//-----------------------------
						if( data.Z < -500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 4,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 4 ] = true;
							this.bButtonPushDown[ 4 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 4,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 4 ] = false;
							this.bButtonPullUp[ 4 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ Z軸＋ ]
						//-----------------------------
						if( data.Z > 500 )
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 5,
									b押された = true,
									nTimeStamp = data.TimeStamp,
									nVelocity = CInput管理.n通常音量,
								} );

							this.bButtonState[ 5 ] = true;
							this.bButtonPushDown[ 5 ] = true;
						}
						else
						{
							this.list入力イベント.Add(
								new CInputEvent() {
									GUID = this.GUID,
									ID = this.ID,
									nKey = 5,
									b押された = false,
									nTimeStamp = data.TimeStamp,
									nVelocity = 0,
								} );

							this.bButtonState[ 5 ] = false;
							this.bButtonPullUp[ 5 ] = true;
						}
						//-----------------------------
						#endregion
						#region [ ボタン ]
						//-----------------------------
						for( int i = 0; i < 32; i++ )
						{
							if( data.IsPressed( i ) )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 6 + i,
										b押された = true,
										nTimeStamp = data.TimeStamp,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 6 + i ] = true;
								this.bButtonPushDown[ 6 + i ] = true;
							}
							else if( data.IsReleased( i ) )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 6 + i,
										b押された = false,
										nTimeStamp = data.TimeStamp,
										nVelocity = 0,
									} );

								this.bButtonState[ 6 + i ] = false;
								this.bButtonPullUp[ 6 + i ] = true;
							}
						}
						//-----------------------------
						#endregion
					}
					//-----------------------------
					#endregion
				}
				else
				{
					#region [ (B) 状態入力 ]
					//-----------------------------
					JoystickState currentState = this.devJoystick.GetCurrentState();
					if( Result.Last.IsSuccess && currentState != null )
					{
						#region [ X軸－ ]
						//-----------------------------
						if( currentState.X < -500 )
						{
							if( this.bButtonState[ 0 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 0,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 0 ] = true;
								this.bButtonPushDown[ 0 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 0 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 0,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 0 ] = false;
								this.bButtonPullUp[ 0 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ X軸＋ ]
						//-----------------------------
						if( currentState.X > 500 )
						{
							if( this.bButtonState[ 1 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 1,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 1 ] = true;
								this.bButtonPushDown[ 1 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 1 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 1,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 1 ] = false;
								this.bButtonPullUp[ 1 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ Y軸－ ]
						//-----------------------------
						if( currentState.Y < -500 )
						{
							if( this.bButtonState[ 2 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 2,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 2 ] = true;
								this.bButtonPushDown[ 2 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 2 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 2,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 2 ] = false;
								this.bButtonPullUp[ 2 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ Y軸＋ ]
						//-----------------------------
						if( currentState.Y > 500 )
						{
							if( this.bButtonState[ 3 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 3,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 3 ] = true;
								this.bButtonPushDown[ 3 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 3 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 3,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 3 ] = false;
								this.bButtonPullUp[ 3 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ Z軸－ ]
						//-----------------------------
						if( currentState.Z < -500 )
						{
							if( this.bButtonState[ 4 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 4,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 4 ] = true;
								this.bButtonPushDown[ 4 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 4 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 4,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 4 ] = false;
								this.bButtonPullUp[ 4 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ Z軸＋ ]
						//-----------------------------
						if( currentState.Z > 500 )
						{
							if( this.bButtonState[ 5 ] == false )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 5,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 5 ] = true;
								this.bButtonPushDown[ 5 ] = true;
							}
						}
						else
						{
							if( this.bButtonState[ 5 ] == true )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 5,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 5 ] = false;
								this.bButtonPullUp[ 5 ] = true;
							}
						}
						//-----------------------------
						#endregion
						#region [ ボタン ]
						//-----------------------------
						bool[] buttons = currentState.GetButtons();
						for( int j = 0; ( j < buttons.Length ) && ( j < 128 ); j++ )
						{
							if( this.bButtonState[ 6 + j ] == false && buttons[ j ] )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 6 + j,
										b押された = true,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = CInput管理.n通常音量,
									} );

								this.bButtonState[ 6 + j ] = true;
								this.bButtonPushDown[ 6 + j ] = true;
							}
							else if( this.bButtonState[ 6 + j ] == true && !buttons[ j ] )
							{
								this.list入力イベント.Add(
									new CInputEvent() {
										GUID = this.GUID,
										ID = this.ID,
										nKey = 6 + j,
										b押された = false,
										nTimeStamp = this.timer.nシステム時刻ms,
										nVelocity = 0,
									} );

								this.bButtonState[ 6 + j ] = false;
								this.bButtonPullUp[ 6 + j ] = true;
							}
						}
						//-----------------------------
						#endregion
					}
					//-----------------------------
					#endregion
				}
			}
		}
		public bool bキーが押された( int nButton )
		{
			return this.bButtonPushDown[ nButton ];
		}
		public bool bキーが押された( Key key )
		{
			return this.bキーが押された( (int) key );
		}
		public bool bキーが押されている( int nButton )
		{
			return this.bButtonState[ nButton ];
		}
		public bool bキーが押されている( Key key )
		{
			return this.bキーが押されている( (int) key );
		}
		public bool bキーが離された( int nButton )
		{
			return this.bButtonPullUp[ nButton ];
		}
		public bool bキーが離された( Key key )
		{
			return this.bキーが離された( (int) key );
		}
		public bool bキーが離されている( int nButton )
		{
			return !this.bButtonState[ nButton ];
		}
		public bool bキーが離されている( Key key )
		{
			return this.bキーが離されている( (int) key );
		}
		//-----------------
		#endregion

		#region [ IDisposable 実装 ]
		//-----------------
		public void Dispose()
		{
			C共通.tDisposeする( ref this.devJoystick );
			C共通.tDisposeする( ref this.timer );
		}
		//-----------------
		#endregion

		#region [ protected ]
		//-----------------
		protected bool[] bButtonPullUp = new bool[ 0x100 ];
		protected bool[] bButtonPushDown = new bool[ 0x100 ];
		protected bool[] bButtonState = new bool[ 0x100 ];
		protected Joystick devJoystick;
		protected CTimer timer;
		//-----------------
		#endregion
	}
}
