﻿using System;
using System.Collections.Generic;
using System.Text;
using SlimDX.DirectInput;

namespace FDK
{
	public class CInputMIDI : IInputDevice, IDisposable
	{
		public uint hMidiIn;
		public List<CInputEvent> listMidi受信用入力イベント;

		public CInputMIDI( uint nID )
		{
			this.hMidiIn = 0;
			this.listMidi受信用入力イベント = new List<CInputEvent>( 32 );
			this.e入力デバイス種別 = E入力デバイス種別.MidiIn;
			this.GUID = null;
			this.ID = (int) nID;
			this.strデバイス名 = "";
		}
		public void tメッセージからMIDI信号のみ受信( uint wMsg, int dwInstance, int dwParam1, int dwParam2, long n受信システム時刻 )
		{
			if( wMsg == CWin32.MIM_DATA )
			{
				int nStatus = dwParam1 & 0xF0;
				int nNote = ( dwParam1 >> 8 ) & 0xFF;
				int nVelocity = ( dwParam1 >> 16 ) & 0xFF;

				if( nStatus == 0x90 && nVelocity != 0 )		// MIDI ノート。
				{
					this.listMidi受信用入力イベント.Add(
						new CInputEvent() {
							GUID = this.GUID,
							ID = this.ID,
							nKey = nNote,
							b押された = true,
							nTimeStamp = n受信システム時刻,
							nVelocity = nVelocity,
						} );
				}
				else if( nStatus == 0xB0 && nNote == 0x04 )	// FootPedalコントロールチェンジ。
				{
					this.listMidi受信用入力イベント.Add(
						new CInputEvent() {
							GUID = this.GUID,
							ID = this.ID,
							nKey = 255,					// FootPedalコントロールの nKey は 255。
							b押された = true,
							nTimeStamp = n受信システム時刻,
							nVelocity = nVelocity,
						} );
				}
			}
		}

		#region [ IInputDevice 実装 ]
		//-----------------
		public E入力デバイス種別 e入力デバイス種別
		{
			get;
			protected set;
		}
		public string GUID 
		{
			get;
			protected set;
		}
		public int ID
		{ 
			get;
			protected set;
		}
		public List<CInputEvent> list入力イベント
		{
			get; 
			protected set;
		}
		public string strデバイス名
		{
			get;
			set;
		}

		public void tポーリング( bool bWindowがアクティブ中, bool bバッファ入力を使用する )
		{
			this.list入力イベント = new List<CInputEvent>( 32 );

			for( int i = 0; i < this.listMidi受信用入力イベント.Count; i++ )
				this.list入力イベント.Add( this.listMidi受信用入力イベント[ i ] );

			this.listMidi受信用入力イベント.Clear();
		}

		public bool bキーが押された( int nKey )
		{
			foreach( CInputEvent ie in this.list入力イベント )
			{
				if( ( ie.nKey == nKey ) && ie.b押された )
					return true;
			}
			return false;
		}
		public bool bキーが押された( Key key )
		{
			return this.bキーが押された( (int) key );
		}
		public bool bキーが押されている( int nKey )
		{
			return false;
		}
		public bool bキーが押されている( Key key )
		{
			return this.bキーが押されている( (int) key );
		}
		public bool bキーが離された( int nKey )
		{
			return false;
		}
		public bool bキーが離された( Key key )
		{
			return this.bキーが離された( (int) key );
		}
		public bool bキーが離されている( int nKey )
		{
			return false;
		}
		public bool bキーが離されている( Key key )
		{
			return this.bキーが離されている( (int) key );
		}
		//-----------------
		#endregion

		#region [ IDisposable 実装 ]
		//-----------------
		public void Dispose()
		{
		}
		//-----------------
		#endregion
	}
}
