﻿using System;
using System.Collections.Generic;
using System.Text;
using SlimDX.DirectInput;

namespace FDK
{
	public interface IInputDevice : IDisposable
	{
		// プロパティ

		E入力デバイス種別 e入力デバイス種別
		{
			get;
		}
		
		/// <summary>
		/// <para>デバイスのGUID。</para>
		/// <para>Joystickの場合のみ使用。その他のデバイスでは常に null。</para>
		/// </summary>
		string GUID 
		{
			get; 
		}

		/// <summary>
		/// <para>デバイス番号。</para>
		/// <para>MIDIの場合：MIDIデバイス番号(0～)</para>
		/// <para>Keyboardの場合：常に 0</para>
		/// <para>Joystickの場合：常に 0</para>
		/// </summary>
		int ID 
		{
			get;
		}
		
		List<CInputEvent> list入力イベント
		{
			get;
		}
		string strデバイス名
		{
			get;
		}

		// メソッドインターフェース

		void tポーリング( bool bWindowがアクティブ中, bool bバッファ入力を使用する );

		bool bキーが押された( int nKey );
		bool bキーが押された( Key key );
		
		bool bキーが押されている( int nKey );
		bool bキーが押されている( Key key );
		
		bool bキーが離された( int nKey );
		bool bキーが離された( Key key );

		bool bキーが離されている( int nKey );
		bool bキーが離されている( Key key );
	}
}
