﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;
using System.IO;

namespace FDK
{
	public static class BitmapUtil
	{
		// 定数

		public const uint DIB_PAL_COLORS = 1;
		public const uint DIB_RGB_COLORS = 0;


		// 構造体

		[StructLayout( LayoutKind.Sequential, Pack = 1 )]
		public struct BITMAPFILEHEADER
		{
			public ushort bfType;
			public uint bfSize;
			public ushort bfReserved1;
			public ushort bfReserved2;
			public uint bfOffBits;
		}

		[StructLayout( LayoutKind.Sequential, Pack = 1 )]
		public struct BITMAPINFOHEADER
		{
			public const int BI_RGB = 0;
			public uint biSize構造体のサイズ;
			public int biWidthビットマップの幅dot;
			public int biHeightビットマップの高さdot;
			public ushort biPlanes面の数;
			public ushort biBitCount;
			public uint biCompression圧縮形式;
			public uint biSizeImage画像イメージのサイズ;
			public int biXPelsPerMete水平方向の解像度;
			public int biYPelsPerMeter垂直方向の解像度;
			public uint biClrUsed色テーブルのインデックス数;
			public uint biClrImportant表示に必要な色インデックスの数;
		}


		// メソッド

		public static unsafe Bitmap ToBitmap( IntPtr pBITMAPINFOHEADER )
		{
			BITMAPINFOHEADER* bitmapInfoHeaderPtr = (BITMAPINFOHEADER*) pBITMAPINFOHEADER;
			
			BITMAPFILEHEADER bitmapFileHeader;
			bitmapFileHeader.bfType = 0x4D42;
			bitmapFileHeader.bfOffBits = (uint) ( sizeof( BITMAPFILEHEADER ) + sizeof( BITMAPINFOHEADER ) );
			bitmapFileHeader.bfSize = bitmapFileHeader.bfOffBits + bitmapInfoHeaderPtr->biSizeImage画像イメージのサイズ;

			byte[] destination;

			var writer = new BinaryWriter( new MemoryStream() );

			destination = new byte[ sizeof( BITMAPFILEHEADER ) ];
			Marshal.Copy( (IntPtr) ( &bitmapFileHeader ), destination, 0, destination.Length );
			writer.Write( destination );

			destination = new byte[ sizeof( BITMAPINFOHEADER ) ];
			Marshal.Copy( pBITMAPINFOHEADER, destination, 0, destination.Length );
			writer.Write( destination );

			destination = new byte[ bitmapInfoHeaderPtr->biSizeImage画像イメージのサイズ ];
			bitmapInfoHeaderPtr++;
			Marshal.Copy( (IntPtr) bitmapInfoHeaderPtr, destination, 0, destination.Length );
			writer.Write( destination );

			writer.Flush();
			writer.BaseStream.Position = 0L;
			
			return new Bitmap( writer.BaseStream );
		}
	}
}
