﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Diagnostics;
using SlimDX.Direct3D9;

namespace FDK
{
	/// <summary>
	/// <para>汎用の文字列表示クラス。</para>
	/// <para>使い方：</para>
	/// <para>(1) 表記可能文字の集合を用意する。（例："0123456789"）これはコンストラクタの文字列引数として渡す。</para>
	/// <para>(2) 表記可能文字をすべて含んだ1枚のテクスチャを用意する。</para>
	/// <para>(3) テクスチャインスタンスの CTexture.list描画範囲 に、(1)の各文字列のテクスチャ内での領域を格納する。(1)の文字列に登場する順番に、文字数分格納する。</para>
	/// <para>(4) t表示() で任意の文字列を描画する。</para>
	/// <para>なお、本クラスでは、与えられたテクスチャのライフサイクル管理は行わない。</para>
	/// </summary>
	public class CMAct文字列描画 : CActivity
	{
		public void t表示( Device D3D9Device, CTexture tx文字盤, int x, int y, string str描画する文字列 )
		{
			// 準正常系チェック。

			if( this.b活性化してない ||
				string.IsNullOrEmpty( this.str表記可能文字 ) ||
				tx文字盤 == null ||
				string.IsNullOrEmpty( str描画する文字列 ) )
				return;


			// 文字列描画。

			int nXの初期値 = x;
			for( int i = 0; i < str描画する文字列.Length; i++ )
			{
				char ch = str描画する文字列[ i ];

				if( ch == '\n' )
				{
					// (A) 改行

					x = nXの初期値;
					y += this.n改行幅px;
				}
				else
				{
					int n = this.str表記可能文字.LastIndexOf( ch );

					// (B) 通常文字

					if( n >= 0 )
					{
						tx文字盤.t2D描画( D3D9Device, x, y, tx文字盤.list描画範囲[ n ] );
						x += tx文字盤.list描画範囲[ n ].Width;
					}

					// (C) 未対応文字は空白扱い
					else
					{
						x += this.n空白幅px;
					}
				}
			}
		}

		public CMAct文字列描画( string str表記可能文字, int n改行幅px, int n空白幅px )
		{
			this.str表記可能文字 = str表記可能文字;
			this.n改行幅px = n改行幅px;
			this.n空白幅px = n空白幅px;
		}
		public CMAct文字列描画( string str表記可能文字, int n改行幅px )
			: this( str表記可能文字, n改行幅px, 8 )
		{
		}

		#region [ protected ]
		//-----------------
		protected string str表記可能文字 = "";
		protected int n改行幅px = 0;
		protected int n空白幅px = 8;
		//-----------------
		#endregion
	}
}
