﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Drawing;
using SlimDX;
using SlimDX.Direct3D9;

namespace FDK
{
	/// <summary>
	/// <para>羽を回転させる点フラッシュ。</para>
	/// <para>大羽４枚・小羽４枚がそれぞれ逆方向に回転する。</para>
	/// </summary>
	public class CMAct点フラッシュ・回転羽 : CActivity
	{
		public void t2D発火( Point pt中央px )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( pt中央px ) );
		}
		public void t2D発火( Vector2 v2中央px )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( v2中央px ) );
		}
		public void t2D発火( int n中央Xpx, int n中央Ypx )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( n中央Xpx, n中央Ypx ) );
		}
		public void t3D発火( float f中央X, float f中央Y, float f中央Z )
		{
			this.t3D発火( new Vector3( f中央X, f中央Y, f中央Z ) );
		}
		public void t3D発火( Vector3 v3中央 )
		{
			float n角度 = this.Random.Next( 360 );

			for( int n羽番号 = 0; n羽番号 < 8; n羽番号++ )	// 0～3:大羽、4～7:小羽
			{
				for( int i = 0; i < this.n羽の最大枚数; i++ )
				{
					if( !this.st羽[ i ].b使用中 )
					{
						this.st羽[ i ].b使用中 = true;
						this.st羽[ i ].ct進行 = new CCounter( 0, 70, 3 );
						this.st羽[ i ].f回転単位 = C共通.DegreeToRadian( (float) ( n角度 + ( n羽番号 * 90.0f ) ) );
						this.st羽[ i ].f回転方向 = ( n羽番号 < 4 ) ? 1.0f : -2.0f;
						this.st羽[ i ].fサイズ = ( n羽番号 < 4 ) ? 1.0f : 0.5f;
						this.st羽[ i ].v3中央 = v3中央;
						break;
					}
				}
			}
		}

		public CMAct点フラッシュ・回転羽( int nフラッシュの最大同時発火数 )
		{
			this.n羽の最大枚数 = nフラッシュの最大同時発火数 * 8;		// 1発火につき8枚羽
			this.st羽 = new ST羽[ this.n羽の最大枚数 ];
		}

		public override void On活性化( Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			// st羽[] の内容をリセット。

			for( int i = 0; i < this.n羽の最大枚数; i++ )
			{
				this.st羽[ i ] = new ST羽() {
					b使用中 = false,
					ct進行 = new CCounter(),
				};
			}

			base.On活性化( D3D9Device );
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			for( int i = 0; i < this.n羽の最大枚数; i++ )
				C共通.tDisposeする( ref this.st羽[ i ].ct進行 );

			base.On非活性化();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return 0;

			for( int i = 0; i < this.n羽の最大枚数; i++ )
			{
				if( this.st羽[ i ].b使用中 )
				{
					if( this.st羽[ i ].ct進行.t進行().b終了値に達した )
					{
						this.st羽[ i ].ct進行.t停止();
						this.st羽[ i ].b使用中 = false;
					}
				}
			}

			return 0;
		}
		/// <summary>
		/// <para>描画範囲は tx羽.list描画範囲[0] とするが、リストが空なら画像全体とする。</para>
		/// </summary>
		public void On描画( Device D3D9Device, CTexture tx羽 )
		{
			if( this.b活性化してない ||
				tx羽 == null )
				return;

			for( int i = 0; i < this.n羽の最大枚数; i++ )
			{
				if( !this.st羽[ i ].b使用中 )
					continue;

				float f進行割合0to1 = ( (float) this.st羽[ i ].ct進行.n現在の値 ) / 70.0f;
				float fZ軸回転率 = this.st羽[ i ].f回転単位 + ( this.st羽[ i ].f回転方向 * C共通.DegreeToRadian( (float) ( 60.0f * f進行割合0to1 ) ) );
				float fX方向拡大率 = ( (float) ( 0.2 + ( 0.8 * Math.Cos( ( ( (double) this.st羽[ i ].ct進行.n現在の値 ) / 50.0 ) * ( Math.PI / 2.0 ) ) ) ) ) * this.st羽[ i ].fサイズ;
				float f移動量 = ( (float) ( 0.8 * Math.Sin( f進行割合0to1 * ( Math.PI / 2.0 ) ) ) ) * this.st羽[ i ].fサイズ;

				var mat = Matrix.Identity;

				mat *= Matrix.Scaling(
					( 0.2f + fX方向拡大率 ) * CTexture.f画面比率,
					( 0.2f + this.st羽[ i ].fサイズ ) * CTexture.f画面比率,
					1.0f * CTexture.f画面比率 );
				
				mat *= Matrix.RotationZ( 
					fZ軸回転率 + (float) ( Math.PI / 2.0 ) );
				
				mat *= Matrix.Translation(
					this.st羽[ i ].v3中央.X + (float) ( Math.Cos( (double) fZ軸回転率 ) * f移動量 ),
					this.st羽[ i ].v3中央.Y + (float) ( Math.Sin( (double) fZ軸回転率 ) * f移動量 ),
					this.st羽[ i ].v3中央.Z );

				if( tx羽.list描画範囲.Count == 0 )
					tx羽.t3D描画( D3D9Device, mat );
				else
					tx羽.t3D描画( D3D9Device, mat, tx羽.list描画範囲[ 0 ] );
			}
		}
	
		#region [ protected ]
		//-----------------
		protected struct ST羽
		{
			public bool b使用中;
			public Vector3 v3中央;
			public float f回転単位;
			public float f回転方向;
			public float fサイズ;
			public CCounter ct進行;
		}
		protected ST羽[] st羽;
		protected int n羽の最大枚数;
		protected readonly Random Random = new Random( DateTime.Now.Millisecond );
		//-----------------
		#endregion
	}
}
