﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Drawing;
using SlimDX;
using SlimDX.Direct3D9;

namespace FDK
{
	/// <summary>
	/// <para>粒子を360度にばらまく点フラッシュ。</para>
	/// <para>軽く下方向への重力がかかる。</para>
	/// </summary>
	public class CMAct点フラッシュ・拡散粒子 : CActivity
	{
		/// <summary>
		/// <para>引数は論理座標。</para>
		/// </summary>
		public void t2D発火( Point pt中央px )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( pt中央px ) );
		}
		/// <summary>
		/// <para>引数は論理座標。</para>
		/// </summary>
		public void t2D発火( Vector2 v2中央px )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( v2中央px ) );
		}
		/// <summary>
		/// <para>引数は論理座標。</para>
		/// </summary>
		public void t2D発火( int n中央Xpx, int n中央Ypx )
		{
			this.t3D発火( CTexture.t論理画面座標をワールド座標へ変換する( n中央Xpx, n中央Ypx ) );
		}
		/// <summary>
		/// <para>引数は、論理座標ではなくワールド座標。</para>
		/// </summary>
		public void t3D発火( float f中央X, float f中央Y, float f中央Z )
		{
			this.t3D発火( new Vector3( f中央X, f中央Y, f中央Z ) );
		}
		/// <summary>
		/// <para>引数は、論理座標ではなくワールド座標。</para>
		/// </summary>
		public void t3D発火( Vector3 v3中央 )
		{
			for( int n粒子番号 = 0; n粒子番号 < this.n1回の発火でばらまく粒子数; n粒子番号++ )
			{
				for( int i = 0; i < this.n粒子の最大数; i++ )
				{
					if( this.st粒子[ i ].b使用中 )
						continue;

					int n角度 = this.Random.Next( 360 );
					double d加速率 = ( 0.9 + ( ( (double) this.Random.Next( 40 ) ) / 100.0 ) ) * CTexture.f画面比率;

					this.st粒子[ i ].b使用中 = true;
					this.st粒子[ i ].v3中央 = v3中央;
					this.st粒子[ i ].f加速度X = (float) ( d加速率 * Math.Cos( ( 2.0 * Math.PI * n角度 ) / 360.0 ) );
					this.st粒子[ i ].f加速度Y = (float) ( d加速率 * ( Math.Sin( ( 2.0 * Math.PI * n角度 ) / 360.0 ) - 0.2 ) );
					this.st粒子[ i ].f加速度の加速度X = 0.995f;
					this.st粒子[ i ].f加速度の加速度Y = 0.995f;
					this.st粒子[ i ].f重力加速度 = 0.00355f;
					this.st粒子[ i ].f半径 = (float) ( 0.5 + ( ( (double) this.Random.Next( 30 ) ) / 100.0 ) ) * CTexture.f画面比率;
					this.st粒子[ i ].n前回の進行カウント値 = -1;
					this.st粒子[ i ].ct進行 = new CCounter( 0, 100, 7 );
					break;
				}
			}
		}

		public CMAct点フラッシュ・拡散粒子( int nフラッシュの最大同時発火数, int n1回の発火でばらまく粒子数 )
		{
			this.n1回の発火でばらまく粒子数 = n1回の発火でばらまく粒子数;
			this.n粒子の最大数 = nフラッシュの最大同時発火数 * n1回の発火でばらまく粒子数;
			this.st粒子 = new ST粒子[ this.n粒子の最大数 ];
		}

		public override void On活性化( Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			// st粒子[] の内容をリセット。

			for( int i = 0; i < this.n粒子の最大数; i++ )
			{
				this.st粒子[ i ] = new ST粒子() {
					b使用中 = false,
					ct進行 = new CCounter(),
				};
			}

			base.On活性化( D3D9Device );
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			for( int i = 0; i < this.n粒子の最大数; i++ )
				C共通.tDisposeする( ref this.st粒子[ i ].ct進行 );

			base.On非活性化();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return 0;

			for( int i = 0; i < this.n粒子の最大数; i++ )
			{
				if( !this.st粒子[ i ].b使用中 )
					continue;

				this.st粒子[ i ].n前回の進行カウント値 = this.st粒子[ i ].ct進行.n現在の値;
			
				if( this.st粒子[ i ].ct進行.t進行().b終了値に達した )
				{
					this.st粒子[ i ].ct進行.t停止();
					this.st粒子[ i ].b使用中 = false;
				}
				else
				{
					for( int n = this.st粒子[ i ].n前回の進行カウント値; n < this.st粒子[ i ].ct進行.n現在の値; n++ )
					{
						this.st粒子[ i ].v3中央.X += this.st粒子[ i ].f加速度X;
						this.st粒子[ i ].v3中央.Y += this.st粒子[ i ].f加速度Y;
						this.st粒子[ i ].f加速度X *= this.st粒子[ i ].f加速度の加速度X;
						this.st粒子[ i ].f加速度Y *= this.st粒子[ i ].f加速度の加速度Y;
						this.st粒子[ i ].f加速度Y -= this.st粒子[ i ].f重力加速度;
					}
				}
			}

			return 0;
		}
		/// <summary>
		/// <para>使用する描画範囲は tx粒子.list描画範囲[0] とする。このリストが空なら画像全体とする。</para>
		/// </summary>
		public void On描画( Device D3D9Device, CTexture tx粒子 )
		{
			if( this.b活性化してない ||
				tx粒子 == null )
				return;

			for( int i = 0; i < this.n粒子の最大数; i++ )
			{
				if( !this.st粒子[ i ].b使用中 )
					continue;

				var mat = Matrix.Identity;
				float xy = (float) ( this.st粒子[ i ].f半径 * Math.Cos( ( ( Math.PI / 2.0 ) * this.st粒子[ i ].ct進行.n現在の値 ) / 100.0 ) ) * CTexture.f画面比率;
				mat *= Matrix.Scaling( xy, xy, 1.0f );
				mat *= Matrix.Translation( this.st粒子[ i ].v3中央 );

				if( tx粒子.list描画範囲.Count == 0 )
					tx粒子.t3D描画( D3D9Device, mat );
				else
					tx粒子.t3D描画( D3D9Device, mat, tx粒子.list描画範囲[ 0 ] );
			}
		}

		#region [ protected ]
		//-----------------
		protected struct ST粒子
		{
			public bool b使用中;
			public Vector3 v3中央;
			public float f加速度X;
			public float f加速度Y;
			public float f加速度の加速度X;
			public float f加速度の加速度Y;
			public float f重力加速度;
			public float f半径;
			public int n前回の進行カウント値;
			public CCounter ct進行;
		}
		protected ST粒子[] st粒子;
		protected int n粒子の最大数;
		protected int n1回の発火でばらまく粒子数;
		protected readonly Random Random = new Random( DateTime.Now.Millisecond );
		//-----------------
		#endregion
	}
}
